summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--NEWS4
-rw-r--r--doc/coreutils.texi7
-rw-r--r--src/copy.c20
-rw-r--r--src/cp.c1
-rwxr-xr-xtests/misc/xattr15
5 files changed, 33 insertions, 14 deletions
diff --git a/NEWS b/NEWS
index 540c5a3cb..766f2716b 100644
--- a/NEWS
+++ b/NEWS
@@ -35,6 +35,10 @@ GNU coreutils NEWS -*- outline -*-
at a time. This was seen to increase throughput. Up to 2 times
when reading cached files on linux for example.
+ cp -a now tries to preserve extended attributes (xattr), but does not
+ diagnose xattr-preservation failure. However, cp --preserve=all still does.
+
+
* Noteworthy changes in release 7.1 (2009-02-21) [stable]
** New features
diff --git a/doc/coreutils.texi b/doc/coreutils.texi
index 2c1fae5c2..0bf978a8e 100644
--- a/doc/coreutils.texi
+++ b/doc/coreutils.texi
@@ -7262,10 +7262,9 @@ Preserve as much as possible of the structure and attributes of the
original files in the copy (but do not attempt to preserve internal
directory structure; i.e., @samp{ls -U} may list the entries in a copied
directory in a different order).
-Try to preserve SELinux security context, but ignore any failure to do that
-and print no corresponding diagnostic.
-This option does not preserve extended attributes(xattr) at the moment.
-Equivalent to @option{-dR --preserve=all} with a few exceptions.
+Try to preserve SELinux security context and extended attributes (xattr),
+but ignore any failure to do that and print no corresponding diagnostic.
+Equivalent to @option{-dR --preserve=all} with the reduced diagnostics.
@item -b
@itemx @w{@kbd{--backup}[=@var{method}]}
diff --git a/src/copy.c b/src/copy.c
index e37fead52..9b0e139c6 100644
--- a/src/copy.c
+++ b/src/copy.c
@@ -159,7 +159,7 @@ copy_attr_free (struct error_context *ctx ATTRIBUTE_UNUSED,
static bool
copy_attr_by_fd (char const *src_path, int src_fd,
- char const *dst_path, int dst_fd)
+ char const *dst_path, int dst_fd, const struct cp_options *x)
{
struct error_context ctx =
{
@@ -167,11 +167,13 @@ copy_attr_by_fd (char const *src_path, int src_fd,
.quote = copy_attr_quote,
.quote_free = copy_attr_free
};
- return 0 == attr_copy_fd (src_path, src_fd, dst_path, dst_fd, 0, &ctx);
+ return 0 == attr_copy_fd (src_path, src_fd, dst_path, dst_fd, 0,
+ x->reduce_diagnostics ? NULL : &ctx);
}
static bool
-copy_attr_by_name (char const *src_path, char const *dst_path)
+copy_attr_by_name (char const *src_path, char const *dst_path,
+ const struct cp_options *x)
{
struct error_context ctx =
{
@@ -179,19 +181,21 @@ copy_attr_by_name (char const *src_path, char const *dst_path)
.quote = copy_attr_quote,
.quote_free = copy_attr_free
};
- return 0 == attr_copy_file (src_path, dst_path, 0, &ctx);
+ return 0 == attr_copy_file (src_path, dst_path, 0,
+ x-> reduce_diagnostics ? NULL :&ctx);
}
#else /* USE_XATTR */
static bool
copy_attr_by_fd (char const *src_path, int src_fd,
- char const *dst_path, int dst_fd)
+ char const *dst_path, int dst_fd, const struct cp_options *x)
{
return true;
}
static bool
-copy_attr_by_name (char const *src_path, char const *dst_path)
+copy_attr_by_name (char const *src_path, char const *dst_path,
+ const struct cp_options *x)
{
return true;
}
@@ -759,7 +763,7 @@ copy_reg (char const *src_name, char const *dst_name,
set_author (dst_name, dest_desc, src_sb);
if (x->preserve_xattr && ! copy_attr_by_fd (src_name, source_desc,
- dst_name, dest_desc)
+ dst_name, dest_desc, x)
&& x->require_preserve_xattr)
return false;
@@ -2076,7 +2080,7 @@ copy_internal (char const *src_name, char const *dst_name,
set_author (dst_name, -1, &src_sb);
- if (x->preserve_xattr && ! copy_attr_by_name (src_name, dst_name)
+ if (x->preserve_xattr && ! copy_attr_by_name (src_name, dst_name, x)
&& x->require_preserve_xattr)
return false;
diff --git a/src/cp.c b/src/cp.c
index af4bd601b..878507616 100644
--- a/src/cp.c
+++ b/src/cp.c
@@ -925,6 +925,7 @@ main (int argc, char **argv)
x.require_preserve = true;
if (selinux_enabled)
x.preserve_security_context = true;
+ x.preserve_xattr = true;
x.reduce_diagnostics = true;
x.recursive = true;
break;
diff --git a/tests/misc/xattr b/tests/misc/xattr
index 4137c53cb..f067ff535 100755
--- a/tests/misc/xattr
+++ b/tests/misc/xattr
@@ -1,6 +1,7 @@
#!/bin/sh
-# Ensure that cp --preserve=xattr and mv preserve extended attributes and
-# install does not preserve extended attributes.
+# Ensure that cp --preserve=xattr, cp --preserve=all and mv preserve extended
+# attributes and install does not preserve extended attributes.
+# cp -a should preserve xattr, error diagnostics should not be displayed
# Copyright (C) 2009 Free Software Foundation, Inc.
@@ -66,6 +67,16 @@ cp --preserve=xattr a b || fail=1
getfattr -d b >out_b || skip_test_ "failed to get xattr of file"
grep -F "$xattr_pair" out_b >/dev/null || fail=1
+#test if --preserve=all option works
+cp --preserve=all a c || fail=1
+getfattr -d c >out_c || skip_test_ "failed to get xattr of file"
+grep -F "$xattr_pair" out_c >/dev/null || fail=1
+
+#test if -a option works without any diagnostics
+cp -a a d 2>err && test -s err && fail=1
+getfattr -d d >out_d || skip_test_ "failed to get xattr of file"
+grep -F "$xattr_pair" out_d >/dev/null || fail=1
+
rm b || framework_failure
# install should never preserve xattr